#include "seller.h"

Seller::Seller() : Entity() {}

Seller::Seller(const std::string& firstName, const std::string& lastName, int sellerNo,
               int numberOfArticles)
    : Entity()
{
    firstName_ = firstName;
    lastName_ = lastName;
    sellerNo_ = sellerNo;
    numberOfOfferedArticles_ = numberOfArticles;
}

inline void Seller::setSellerNo(int seller_no) { sellerNo_ = seller_no; }

inline void Seller::setFirstName(const std::string& firstName) { firstName_ = firstName; }

inline void Seller::setLastName(const std::string& lastName) { lastName_ = lastName; }

inline void Seller::setNumberOfOfferedArticles(int number) { numberOfOfferedArticles_ = number; }

inline size_t Seller::getNumberOfOfferedArticles() { return articles_.size(); }

void Seller::addArticle(Article article) {
    articles_.push_back(article);
}

std::vector<Article*> Seller::getArticles(bool onlySold)
{
    std::vector<Article*> articles;
    for (auto& article : articles_) {
        if (onlySold && article.isSold()) {
            articles.push_back(&article);
        } else if (!onlySold) {
            articles.push_back(&article);
        }
    }
    return articles;
}